/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the CaptchaAnswer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CaptchaAnswer{}

// CaptchaAnswer struct for CaptchaAnswer
type CaptchaAnswer struct {
	Id     *string        `json:"id,omitempty"`
	Answer NullableString `json:"answer,omitempty"`
}

// NewCaptchaAnswer instantiates a new CaptchaAnswer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCaptchaAnswer() *CaptchaAnswer {
	this := CaptchaAnswer{}
	return &this
}

// NewCaptchaAnswerWithDefaults instantiates a new CaptchaAnswer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCaptchaAnswerWithDefaults() *CaptchaAnswer {
	this := CaptchaAnswer{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *CaptchaAnswer) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CaptchaAnswer) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *CaptchaAnswer) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *CaptchaAnswer) SetId(v string) {
	o.Id = &v
}

// GetAnswer returns the Answer field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *CaptchaAnswer) GetAnswer() string {
	if o == nil || IsNil(o.Answer.Get()) {
		var ret string
		return ret
	}
	return *o.Answer.Get()
}

// GetAnswerOk returns a tuple with the Answer field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CaptchaAnswer) GetAnswerOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Answer.Get(), o.Answer.IsSet()
}

// HasAnswer returns a boolean if a field has been set.
func (o *CaptchaAnswer) HasAnswer() bool {
	if o != nil && o.Answer.IsSet() {
		return true
	}

	return false
}

// SetAnswer gets a reference to the given NullableString and assigns it to the Answer field.
func (o *CaptchaAnswer) SetAnswer(v string) {
	o.Answer.Set(&v)
}

// SetAnswerNil sets the value for Answer to be an explicit nil
func (o *CaptchaAnswer) SetAnswerNil() {
	o.Answer.Set(nil)
}

// UnsetAnswer ensures that no value is present for Answer, not even an explicit nil
func (o *CaptchaAnswer) UnsetAnswer() {
	o.Answer.Unset()
}

func (o CaptchaAnswer) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CaptchaAnswer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.Answer.IsSet() {
		toSerialize["answer"] = o.Answer.Get()
	}
	return toSerialize, nil
}

type NullableCaptchaAnswer struct {
	value *CaptchaAnswer
	isSet bool
}

func (v NullableCaptchaAnswer) Get() *CaptchaAnswer {
	return v.value
}

func (v *NullableCaptchaAnswer) Set(val *CaptchaAnswer) {
	v.value = val
	v.isSet = true
}

func (v NullableCaptchaAnswer) IsSet() bool {
	return v.isSet
}

func (v *NullableCaptchaAnswer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCaptchaAnswer(val *CaptchaAnswer) *NullableCaptchaAnswer {
	return &NullableCaptchaAnswer{value: val, isSet: true}
}

func (v NullableCaptchaAnswer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCaptchaAnswer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
